This endpoint provides results from the “Reviews” element of Google SERPs. The results are specific to the selected location (see the List of Locations) and language (see the List of Languages) parameters.
Note: your account will be charged for every 10 reviews returned in the items array, e.g. if you specify "depth": 11, you will be charged as per 20 reviews.
POST
Pricing
Your account will be charged for setting a task and the number of reviews you will get in the items array. The cost can be calculated on the Pricing page.
All POST data should be sent in the JSON format (UTF-8 encoding). Task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 10000 API calls per minute, with each POST call containing no more than 100 tasks. If your POST call contains over 100 tasks, the tasks over this limit will return the 40006 error.
You can retrieve the results of completed tasks using the unique task identifier id. Alternatively, we can send them to you as soon as they are ready if you specify the postback_url or pingback_url when setting a task. Note that if your server doesn’t respond within 10 seconds, the connection will be aborted by timeout, and the task will be transferred to the ‘Tasks Ready’ list. The error code and message depend on your server’s configuration. See Help Center to learn more about using pingbacks and postbacks with DataForSEO APIs.
Below you will find a detailed description of the fields you can use for setting a task.
Description of the fields for setting a task:
Field name
Type
Description
keyword
string
keyword required field if you don't specify cid or place_id the keyword you specify should indicate the name of the local establishment; you can specify up to 700 characters in the keyword filed; all %## will be decoded (plus character ‘+’ will be decoded to a space character) if you need to use the “%” character for your keyword, please specify it as “%25”;
if this field contains such parameters as ‘allinanchor:’, ‘allintext:’, ‘allintitle:’, ‘allinurl:’, ‘define:’, ‘filetype:’, ‘id:’, ‘inanchor:’, ‘info:’, ‘intext:’, ‘intitle:’, ‘inurl:’, ‘link:’, ‘related:’, ‘site:’, the charge per task will be multiplied by 5 Note: queries containing the ‘cache:’ parameter are not supported and will return a validation error
learn more about rules and limitations of keyword and keywords fields in DataForSEO APIs in this Help Center article
cid
string
unique, google-defined id of the business entity required field if you don't specify keyword or place_id example: 194604053573767737 learn more about the identifier in this help center article
place_id
string
identifier of the business entity in Google Maps required field if you don't specify keyword or cid example: GhIJQWDl0CIeQUARxks3icF8U8A learn more about the identifier in this help center article
priority
integer
task priority optional field can take the following values: 1 – normal execution priority (set by default) 2 – high execution priorityYou will be additionally charged for the tasks with high execution priority. The cost can be calculated on the Pricing page.
location_name
string
full name of search engine location required field if you don't specifylocation_code or location_coordinate if you use this field, you don't need to specify location_code or location_coordinate you can receive the list of available locations with location_name by making a separate request to the https://api.dataforseo.com/v3/business_data/google/locations example: London,England,United Kingdom
location_code
integer
search engine location code required field if you don't specifylocation_name_or location_coordinate if you use this field, you don't need to specify location_name or location_coordinate you can receive the list of available locations with location_code by making a separate request to the https://api.dataforseo.com/v3/business_data/google/locations example: 2840
location_coordinate
string
GPS coordinates of a location required field if you don't specifylocation_name_or location_code if you use this field, you don't need to specify location_name or location_code location_coordinate parameter should be specified in the "latitude,longitude,radius" format the maximum number of decimal digits for "latitude" and "longitude": 7 the minimum value for "radius": 199.9 example: 53.476225,-2.243572,200
language_name
string
full name of search engine language required field if you don't specifylanguage_code if you use this field, you don't need to specify language_code you can receive the list of available languages with language_name by making a separate request to the https://api.dataforseo.com/v3/business_data/google/languages example: English
language_code
string
search engine language code required field if you don't specifylanguage_name if you use this field, you don't need to specify language_name you can receive the list of available languages with their language_code_by making a separate request to the https://api.dataforseo.com/v3/business_data/google/languages example: en
depth
integer
parsing depth optional field number of reviews in SERP we strongly recommend setting the parsing depth in the multiples of ten, because our systems processes ten reviews in a row default value: 10 maximum value: 4490 Your account will be billed per each SERP containing up to 10 results; Setting depth above 10 may result in additional charges if the search engine returns more than 10 results; The cost can be calculated on the Pricing page.
sort_by
string
results sorting parameters optional field you can use this field to sort the results possible types of sorting: newest – sort by newest first highest_rating – sort by highest rating lowest_rating – sort by lowest rating relevant – sort by relevance default value: relevant
tag
string
user-defined task identifier optional field the character limit is 255 you can use this parameter to identify the task and match it with the result you will find the specified tag value in the data object of the response
postback_url
string
URL for sending task results optional field once the task is completed, we will send a POST request with its results compressed in the gzip format to the postback_url you specified you can use the ‘$id’ string as a $id variable and ‘$tag’ as urlencoded $tag variable. We will set the necessary values before sending the request. example: http://your-server.com/postbackscript?id=$id http://your-server.com/postbackscript?id=$id&tag=$tag Note: special characters in postback_url will be urlencoded; i.a., the # character will be encoded into %23
notification URL of a completed task optional field when a task is completed we will notify you by GET request sent to the URL you have specified you can use the ‘$id’ string as a $id variable and ‘$tag’ as urlencoded $tag variable. We will set the necessary values before sending the request. example: http://your-server.com/pingscript?id=$id http://your-server.com/pingscript?id=$id&tag=$tag Note: special characters in pingback_url will be urlencoded; i.a., the # character will be encoded into %23
As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.
Description of the fields in the results array:
Field name
Type
Description
version
string
the current version of the API
status_code
integer
general status code you can find the full list of the response codes here Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions
status_message
string
general informational message you can find the full list of general informational messages here
time
string
execution time, seconds
cost
float
total tasks cost, USD
tasks_count
integer
the number of tasks in the tasksarray
tasks_error
integer
the number of tasks in the tasks array returned with an error
status code of the task generated by DataForSEO; can be within the following range: 10000-60000
status_message
string
informational message of the task
time
string
execution time, seconds
cost
float
cost of the task, USD
result_count
integer
number of elements in the result array
path
array
URL path
data
object
contains the same parameters that you specified in the POST request
result
array
array of results in this case, the value will be null
Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access
# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
login="login"
password="password"
cred="$(printf ${login}:${password} | base64)"
curl --location --request POST "https://api.dataforseo.com/v3/business_data/google/reviews/task_post"
--header "Authorization: Basic ${cred}"
--header "Content-Type: application/json"
--data-raw '[
{
"location_name": "London,England,United Kingdom",
"language_name": "English",
"keyword": "hedonism wines",
"depth": 50,
"sort_by": "highest_rating"
}
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
$client = new RestClient($api_url, null, 'login', 'password');
$post_array = array();
// example #1 - a simple way to set a task
// this way requires you to specify a location, a language of search, and a keyword.
$post_array[] = array(
"location_name" => "London,England,United Kingdom",
"language_name" => "English",
"keyword" => mb_convert_encoding("hedonism wines", "UTF-8")
);
// example #2 - a way to set a task with additional parameters
// high priority allows us to complete a task faster, but you will be charged more money.
// after a task is completed, we will send a GET request to the address you specify. Instead of $id and $tag, you will receive actual values that are relevant to this task.
$post_array[] = array(
"location_name" => "London,England,United Kingdom",
"language_name" => "English",
"keyword" => mb_convert_encoding("hedonism wines", "UTF-8"),
"depth" => 50,
"sort_by" => "highest_rating",
"priority" => 2,
"tag" => "some_string_123",
"pingback_url" => 'https://your-server.com/pingscript?id=$id&tag=$tag'
);
// example #3 - an alternative way to set a task
// after a task is completed, we will send the results according to the address you set in the 'postback_url' field.
$post_array[] = array(
"location_name" => "London,England,United Kingdom",
"language_name" => "English",
"keyword" => mb_convert_encoding("hedonism wines", "UTF-8"),
"postback_url" => "https://your-server.com/postbackscript"
);
// this example has a 3 elements, but in the case of large number of tasks - send up to 100 elements per POST request
if (count($post_array) > 0) {
try {
// POST /v3/business_data/google/reviews/task_post
$result = $client->post('/v3/business_data/google/reviews/task_post', $post_array);
print_r($result);
// do something with post result
} catch (RestClientException $e) {
echo "n";
print "HTTP code: {$e->getHttpCode()}n";
print "Error code: {$e->getCode()}n";
print "Message: {$e->getMessage()}n";
print $e->getTraceAsString();
echo "n";
}
}
$client = null;
?>
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
location_name="London,England,United Kingdom",
language_name="English",
keyword="hedonism wines"
)
# after a task is completed, we will send a GET request to the address you specify
# instead of $id and $tag, you will receive actual values that are relevant to this task
post_data[len(post_data)] = dict(
location_name="London,England,United Kingdom",
language_name="English",
keyword="hedonism wines",
depth=50,
sort_by="highest_rating",
priority=2,
tag="some_string_123",
pingback_url="https://your-server.com/pingscript?id=$id&tag=$tag"
)
# after a task is completed, we will send a GET request to the address you specify
# instead of $id and $tag, you will receive actual values that are relevant to this task
post_data[len(post_data)] = dict(
location_name="London,England,United Kingdom",
language_name="English",
keyword="hedonism wines",
postback_url="https://your-server.com/postbackscript"
)
# POST /v3/business_data/google/reviews/task_post
response = client.post("/v3/business_data/google/reviews/task_post", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
print(response)
# do something with result
else:
print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
namespace DataForSeoDemos
{
public static partial class Demos
{
public static async Task business_data_google_reviews_task_post()
{
var httpClient = new HttpClient
{
BaseAddress = new Uri("https://api.dataforseo.com/"),
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
};
var postData = new List<object>();
// simple way to set a task
postData.Add(new
{
location_name = "London,England,United Kingdom",
language_name = "English",
keyword = "hedonism wines"
});
// after a task is completed, we will send a GET request to the address you specify
// instead of $id and $tag, you will receive actual values that are relevant to this task
postData.Add(new
{
location_name = "London,England,United Kingdom",
language_name = "English",
keyword = "hedonism wines",
depth = 50,
sort_by = "highest_rating",
priority = 2,
tag = "some_string_123",
pingback_url = "https://your-server.com/pingscript?id=$id&tag=$tag"
});
// after a task is completed, we will send a GET request to the address you specify
// instead of $id and $tag you will receive actual values that are relevant to this task
postData.Add(new
{
location_name = "London,England,United Kingdom",
language_name = "English",
keyword = "hedonism wines",
postback_url = "https://your-server.com/postbackscript"
});
// POST /v3/business_data/google/reviews/task_post
var taskPostResponse = await httpClient.PostAsync("/v3/business_data/google/reviews/task_post", new StringContent(JsonConvert.SerializeObject(postData)));
var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
// you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if (result.status_code == 20000)
{
// do something with result
Console.WriteLine(result);
}
else
Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
}
}
}
The above command returns JSON structured like this: